#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "ldbm.h"
#include "../slap.h"

usage( name )
char	*name;
{
	fprintf( stderr, "usage: %s [-n] <filename>\n", name );
	exit( 1 );
}

main( argc, argv )
    int		argc;
    char	**argv;
{
	Datum		key, last, data;
	LDBM		dbp;
	int			rc, type;
	long		id;
	char		*s;
	int			printid = 1;

	if ( argc < 2 || argc > 3 || argc == 3 && strcmp( argv[1], "-n" ) != 0 ) {
		usage( argv[0] );
	}
	if ( argc == 3 && strcmp( argv[1], "-n" ) == 0 ) {
		printid = 0;
	}

	if ( (dbp = ldbm_open( argv[1], LDBM_READER, 0, 0 )) == NULL ) {
		perror( argv[1] );
		exit ( 1 );
	}

        last.dptr = NULL;
        for ( key = ldbm_firstkey( dbp ); key.dptr != NULL;
            key = ldbm_nextkey( dbp, last ) ) {
                if ( last.dptr != NULL )
                        ldbm_datum_free( dbp, last );
                data = ldbm_fetch( dbp, key );
				if ( printid ) {
					s = data.dptr;
				} else {
					s = strchr( data.dptr, '\n' ) + 1;
				}
                puts( s );
                ldbm_datum_free( dbp, data );
                last = key;
        }
        if ( last.dptr != NULL )
                ldbm_datum_free( dbp, last );
	ldbm_close( dbp );

	exit( 0 );
}
