#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "lber.h"
#include "ldap.h"

int	ldap_syslog;
int	ldap_syslog_level;

usage( name )
char	*name;
{
	fprintf( stderr, "usage: %s [-b] <attrtype>\n", name );
	exit( 1 );
}

main( argc, argv )
    int		argc;
    char	**argv;
{
	char	buf[BUFSIZ];
	char	*val, *v, *out;
	char	*save, *next, *type;
	int	nread, vsize;
	int	max, cur;
	int	tlen;
	int	binary = 0;

	if (argc < 2 || argc > 3 ) {
		usage( argv[0] );
	}
	if ( argc == 3 ) {
		if ( strcmp( argv[1], "-b" ) != 0 ) {
			usage( argv[0] );
		} else {
			binary = 1;
			type = argv[2];
		}
	} else {
		if ( strcmp( argv[1], "-b" ) == 0 ) {
			usage( argv[0] );
		}
		type = argv[1];
	}

	val = (char *) malloc( BUFSIZ );
	max = BUFSIZ;
	cur = 0;
	while ( (nread = read( 0, buf, BUFSIZ )) != 0 ) {
		if ( nread + cur > max ) {
			max += BUFSIZ;
			val = (char *) realloc( buf, max );
		}
		memcpy( val + cur, buf, nread );
		cur += nread;
	}

	tlen = strlen( type );
	if ( binary ) {
		/* allocate space for type + ":: " + b64-encoded value + \n */
		out = (char *) malloc( tlen + 4 + (cur * 4 / 3) );
		save = out;
		put_type_and_value( &out, type, val, cur );
		fputs( save, stdout );
		exit( 0 );
	}

	v = val;
	do {
		if ( (next = strchr( v, '\n' )) != NULL ) {
			*next++ = '\0';
		}
		vsize = strlen( v );

		/* allocate space for type + ":: " + b64-encoded value + \n */
		out = (char *) malloc( tlen + 4 + (vsize * 4 / 3) );
		save = out;
		put_type_and_value( &out, type, v, vsize );
		fputs( save, stdout );

		v = next;
	} while ( next != NULL && next < val + cur );

	exit( 0 );
}
